/*
*ProtectMe source code -- http://maxence-dev.blogspot.com/
*Copyright (C) 2008  Maxence Ardouin <maxthebest.dev@gmail.com>
*
*This program is free software: you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation, either version 3 of the License, or
*(at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <pspkernel.h> 
#include <pspdebug.h> 
#include <pspdisplay.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pspctrl.h>
#include <pspiofilemgr.h>
void Aff_Interface();
void install_doc();
#include "protect.h"
SceCtrlData pad;
#include "basic.c"
#include "password.h"
#include "doc.h"
#include "index.h"
#define Wait wait
#define mkdir sceIoMkdir 
#define printf pspDebugScreenPrintf
PSP_MODULE_INFO("Password setter", 0, 1, 1); 
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

//Functions
int main2(void);

void Display1(char message[67],int t9)
{
    pspDebugScreenSetTextColor(0x00FF0000);
    pspDebugScreenSetXY(0,5);
	printf("%s",message);
	Wait(t9);
	pspDebugScreenSetXY(0,5);
	printf("                                                                    ");
	pspDebugScreenSetXY(0,6);
    printf("--------------------------------------------------------------------");//68
}

void Display(char message[67],int t9,int STATE)
{
    if(STATE)
	{
	pspDebugScreenSetTextColor(0x00FF0000);
    pspDebugScreenSetXY(0,4);
	printf("%s",message);
	Wait(t9);
	}
	else if(!STATE)
	{
	Wait(t9);
	pspDebugScreenSetTextColor(0x00FF0000);
	pspDebugScreenSetXY(0,4);
	printf("                                                                    ");
	pspDebugScreenSetXY(0,5);
    printf("--------------------------------------------------------------------");//68
	}
}


void install_doc()
{
int filemax = 0;
filemax = sceIoOpen("ms0:/Protect-Me.html",PSP_O_WRONLY|PSP_O_CREAT, 0777);
sceIoWrite(filemax, index1, index_SIZE);
sceIoClose(filemax);
int filemax1 = 0;
filemax1 = sceIoOpen("ms0:/Protect-Me-Guide_FR.pdf",PSP_O_WRONLY|PSP_O_CREAT, 0777);
sceIoWrite(filemax1, guide, guide_SIZE);
sceIoClose(filemax1);
}


int install()
{
Display("Plugin installed with success...",1,1);
int filemax = 0;
filemax = sceIoOpen("ms0:/seplugins/protectme.prx",PSP_O_WRONLY|PSP_O_CREAT, 0777);
sceIoWrite(filemax, protectme, protectme_SIZE);
sceIoClose(filemax);
Display(" ",3,0);
return 1;
}



void un_all()
{
Display("Plugin uninstalled with success...",1,1);
sceIoRemove("ms0:/seplugins/protectme.prx");
sceIoRemove("ms0:/PSP/SYSTEM/hist.txt");
sceIoRemove("ms0:/PSP/SYSTEM/iso.m33");
Display("Plugin uninstalled with success...",3,0);
}

void un_pw()
{
Display("Password deleted with success...",1,1);
sceIoRemove("ms0:/PSP/SYSTEM/iso.m33");
Display("Password deleted with success...",3,0);
}

void un_hist()
{
Display("History deleted with success...",1,1);
sceIoRemove("ms0:/PSP/SYSTEM/hist.txt");
Display("History deleted with success...",3,0);
}

void create_dir()
{
char chaine[100];
int yesno = 0;
if(opendir("ms0:/PSP")==NULL)
{
mkdir("ms0:/PSP", 0777);
}
if(opendir("ms0:/PSP/SYSTEM")==NULL)
{
mkdir("ms0:/PSP/SYSTEM", 0777);
}
if(opendir("ms0:/seplugins")==NULL)
{
mkdir("ms0:/seplugins", 0777);
}
FILE *vshtxt = fopen("ms0:/seplugins/vsh.txt", "r");
if(vshtxt==NULL)
{
fclose(vshtxt);
vshtxt = fopen("ms0:/seplugins/vsh.txt","w");
fprintf(vshtxt,"ms0:/seplugins/protectme.prx");
fclose(vshtxt);
}
else
{
while (fgets(chaine, 100, vshtxt) != NULL) // On lit le fichier tant qu'on ne re�oit pas d'erreur (NULL)
{
if(chaine[0] =='m' && chaine[1] == 's' && chaine[3] == ':' && chaine[4] == '/' && chaine[5] == 's' && chaine[6] == 'e' && chaine[7] == 'p' && chaine[8] == 'l' && chaine[9] == 'u' && chaine[10] == 'g' && chaine[11] == 'i' && chaine[12] == 'n' && chaine[13] == 's'&& chaine[14] == '/' && chaine[15] == 'p' && chaine[16] == 'r' && chaine[17] == 'o' && chaine[18] == 't' && chaine[19] == 'e' && chaine[20] == 'c' && chaine[21] == 't' && chaine[22] == 'm' && chaine[23] == 'e' && chaine[24] == '.' && chaine[25] == 'p' && chaine[26] == 'r' && chaine[27] == 'x')
{
yesno = 1;
break;
}
}
if(yesno==1)
{
fclose(vshtxt);
}
else
{
fclose(vshtxt);
vshtxt = fopen("ms0:/seplugins/vsh.txt","a+");
fprintf(vshtxt,"\nms0:/seplugins/protectme.prx");
fclose(vshtxt);
}
}
}

void Aff_menu(int sel)
{
pspDebugScreenSetTextColor(0xffffffff);
pspDebugScreenSetXY(5,7);
printf("Install prx.");
pspDebugScreenSetXY(5,9);
printf("Set Password");
pspDebugScreenSetXY(5,11);
printf("Delete password");
pspDebugScreenSetXY(5,13);
printf("Uninstall password, history file and prx");
pspDebugScreenSetXY(5,15);
printf("Delete History file");
pspDebugScreenSetXY(5,17);
printf("Options");
pspDebugScreenSetXY(5,19);
printf("Credits");
pspDebugScreenSetXY(5,21);
printf("Exit to XMB");
if(sel==0)
{
pspDebugScreenSetTextColor(0x000A0AEE);
pspDebugScreenSetXY(5,7);
printf("Install prx.");
}
if(sel==1)
{
pspDebugScreenSetTextColor(0x000A0AEE);
pspDebugScreenSetXY(5,9);
printf("Set Password");
}
if(sel==2)
{
pspDebugScreenSetTextColor(0x000A0AEE);
pspDebugScreenSetXY(5,11);
printf("Delete password");
}
if(sel==3)
{
pspDebugScreenSetTextColor(0x000A0AEE);
pspDebugScreenSetXY(5,13);
printf("Uninstall password, history file and prx");
}
if(sel==4)
{
pspDebugScreenSetTextColor(0x000A0AEE);
pspDebugScreenSetXY(5,15);
printf("Delete History file");
}
if(sel==5)
{
pspDebugScreenSetTextColor(0x000A0AEE);
pspDebugScreenSetXY(5,17);
printf("Options");
}
if(sel==6)
{
pspDebugScreenSetTextColor(0x000A0AEE);
pspDebugScreenSetXY(5,19);
printf("Credits");
}
if(sel==7)
{
pspDebugScreenSetTextColor(0x000A0AEE);
pspDebugScreenSetXY(5,121);
printf("Exit to XMB");
}
}


void Aff_Interface()
{
pspDebugScreenSetTextColor(0x77777777);
pspDebugScreenSetXY(0,0);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetXY(0,1);
printf("--                                                                --");
pspDebugScreenSetTextColor(0xffffffff);
pspDebugScreenSetXY(13,1);
printf("MaxTheBest's Protect-Me Installer %s",V);//68
pspDebugScreenSetTextColor(0x77777777);
pspDebugScreenSetXY(0,2);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetTextColor(0x00FF0000);
pspDebugScreenSetXY(0,3);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetXY(0,5);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetTextColor(0x77777777);
pspDebugScreenSetXY(0,28);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetXY(0,32);
printf("--------------------------------------------------------------------");//68//Last one ^^


}



int check(char password[8])
{
int i = 0;
wait(2);
pspDebugScreenClear();
Aff_Interface();
pspDebugScreenSetTextColor(0xffffffff);
pspDebugScreenSetXY(5,15);
printf("Are you sure you want to set \"%c%c%c%c%c%c%c%c\" as password?",password[0],password[1],password[2],password[3],password[4],password[5],password[6],password[7]);
pspDebugScreenSetXY(5,19);
printf("X: Yes!                   O: No!");
while(1)
{
sceCtrlReadBufferPositive (&pad, 1);
if(pad.Buttons & PSP_CTRL_CROSS)
{
i = 1;
while(1)
{
sceCtrlReadBufferPositive (&pad, 1);
if(!pad.Buttons){
break;
}
}
break;
}
if(pad.Buttons & PSP_CTRL_CIRCLE)
{
i = 2;
while(1)
{
sceCtrlReadBufferPositive (&pad, 1);
if(!pad.Buttons){
break;
}
}
break;
}
}
if(i==1)
{
FILE* save = NULL;
save = fopen("ms0:/PSP/SYSTEM/iso.m33", "w+");
Display("Password installed with success...",1,1);
fprintf(save,"%c%c%c%c%c%c%c%c",password[0]+1,password[1]+2,password[2]+3,password[3]+4,password[4]+5,password[5]+6,password[6]+7,password[7]+8);
fclose(save);
Display("Password installed with success...",3,0);
return 1;
}
if(i==2)
{
pspDebugScreenClear();
menu();
}
}


void menu()
{
   int quit=0;
   int select = 0;
   int sel = 0;
   int save=0;
   char word[8];
   word[0]='a';
   word[1]='a';
   word[2]='a';
   word[3]='a';
   word[4]='a';
   word[5]='a';
   word[6]='a';
   word[7]='a';
   word[8]='\0';
   char rword[8];
   rword[0]='a';
   rword[1]='a';
   rword[2]='a';
   rword[3]='a';
   rword[4]='a';
   rword[5]='a';
   rword[6]='a';
   rword[7]='a';
   rword[8]='\0';
   u32 buttonsold = 0;
   Aff_Interface();
    pspDebugScreenSetBackColor(0x00000000);
    pspDebugScreenSetTextColor(0x77777777);
    pspDebugScreenSetXY(0,29);
    printf("Press X to validate letter, O or Triangle or Square to go back\nStart to set actual password\nR to go right or L to go left");
   word[0] = rword[0];
   word[1] = rword[1];
   word[2] = rword[2];
   word[3] = rword[3];
   word[4] = rword[4];
   word[5] = rword[5];
   word[6] = rword[6];
   word[7] = rword[7];
   word[8]='\0';
   Aff(select,sel,save,word,rword);
   while(quit == 0)
   {
      SceCtrlData pad;
      sceCtrlPeekBufferPositive(&pad, 1);
	  save = 0;
	  //quit = Aff(select,sel,save,word,rword);
	  if (quit == 1)
	  {
	  break;
	  }
	  //rword = Aff(select,sel,save,word);
	  //word = rword;
	  //sprintf(word,"%s",rword);
	  if (pad.Buttons != buttonsold) 
	  {
	  if(pad.Buttons & PSP_CTRL_LEFT)
	  {
	  select = select-1;
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_RIGHT)
	  {
	  select = select+1;
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_UP)
	  {
	  //MODIFIED
	  if(select>=10 && select<=25)
	  {
	  select = select-10;
	  }
	  else if(select>=26 && select<31)
	  {
	  select = select - 6;
	  }
	  else if(select>=31)
	  {
	  select = 25;
	  }
	  //END
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_DOWN)
	  {
	  //MODIFIED!!!
	  if(select>=0 && select<=15)
	  {
	  select = select + 10;
	  }
	  else if(select>=16 && select<=19)
	  {
	  select = 25;
	  }
	  else if(select>=20 && select<=25)
	  {
	  select = select + 6;
	  }
	  else if(select>=25)
	  {
	  select = 35;
	  }
	  //End 
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_LTRIGGER)
	  {
	  sel = sel-1;
	  if (sel<0)
	  {
	  sel=7;
	  }
	  if (sel>7)
	  {
	  sel=0;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_RTRIGGER)
	  {
	  sel = sel+1;
	  if (sel<0)
	  {
	  sel=7;
	  }
	  if (sel>7)
	  {
	  sel=0;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_CROSS)
	  {
	  quit = Aff(select,sel,65,word,rword);
	  word[0] = rword[0];
      word[1] = rword[1];
      word[2] = rword[2];
      word[3] = rword[3];
      word[4] = rword[4];
      word[5] = rword[5];
      word[6] = rword[6];
      word[7] = rword[7];
      word[8]='\0';
	  sel = sel+1;
	  if (sel<0)
	  {
	  sel=7;
	  }
	  if (sel>7)
	  {
	  sel=0;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_START)
	  {
	  Aff(select,sel,89,word,rword);
	  word[0] = rword[0];
      word[1] = rword[1];
      word[2] = rword[2];
      word[3] = rword[3];
      word[4] = rword[4];
      word[5] = rword[5];
      word[6] = rword[6];
      word[7] = rword[7];
      word[8]='\0';
	  }
	  if(pad.Buttons & PSP_CTRL_SQUARE)
	  {
	  Aff(select,sel,49,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_CIRCLE)
	  {
	  Aff(select,sel,49,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_TRIANGLE)
	  {
	  Aff(select,sel,49,word,rword);
	  }
	  buttonsold = pad.Buttons;
	  }
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  if (sel<0)
	  {
	  sel=7;
	  }
	  if (sel>7)
	  {
	  sel=0;
	  }
	  //Aff(select,sel,save,word,rword);
	  //sprintf(word,"%s",rword);
   }
}




int main2(void)
{
   u32 buttonsold = 0;
   int quit = 1;
   int sel = 0;
   quit = 1;
   char word2[8];
   word2[0]='a';
   word2[1]='a';
   word2[2]='a';
   word2[3]='a';
   word2[4]='a';
   word2[5]='a';
   word2[6]='a';
   word2[7]='a';
   word2[8]='\0';
   char word[8];
   word[0]='a';
   word[1]='a';
   word[2]='a';
   word[3]='a';
   word[4]='a';
   word[5]='a';
   word[6]='a';
   word[7]='a';
   word[8]='\0';
   pspDebugScreenClear();
   Aff_Interface();
   //////////////////////////////////////////////////////////////////////////////////////////////////pspDebugScreenSetXY(0,16); is middle of screen;
   while(1)
   {
   sceCtrlReadBufferPositive (&pad, 1);
   Aff_menu(sel);
   if (pad.Buttons != buttonsold) 
	  {
   if (pad.Buttons & PSP_CTRL_HOME)
	{
	Display("Exiting...",3,1);
	sceKernelExitGame();
    }
	if (pad.Buttons & PSP_CTRL_UP)
	{
	sel = sel -1;
	}
	if (pad.Buttons & PSP_CTRL_DOWN)
	{
	sel = sel +1;
	}
	if(sel<0)
	{
	sel=7;
	}
	if(sel>7)
	{
	sel=0;
	}
	if (pad.Buttons & PSP_CTRL_CROSS)
	{
	if(sel==0)
	{
	install();
	}
	if(sel==1)
	{
	while(1)
	{
	sceCtrlReadBufferPositive (&pad, 1);
	if(!pad.Buttons)
	{
	break;
	}
	}
	pspDebugScreenClear();
	pspDebugScreenSetTextColor(0xffffffff);
	Aff(0,0,0,word,word2);
    menu();
	}
	if(sel==2)
	{
	un_pw();
	}
	if(sel==3)
	{
	un_all();
	}
	if(sel==4)
	{
	un_hist();
	}
	if(sel==5)
	{
	while(1)
{
sceCtrlReadBufferPositive (&pad, 1);
if(!pad.Buttons)
{
break;
}
}
	Options();
	Aff_Interface();
	}
	if(sel==6)
	{
	Credits(0);
	Aff_Interface();
	}
	if(sel==7)
	{
	Credits(1);
	sceKernelExitGame();
	}
	}
	buttonsold = pad.Buttons;
}
}
}


int main(void)
{
pspDebugScreenInit();
create_dir();
Display_Splash_Iso();
main2();
return 0;
sceKernelSleepThread();
}

