/*
*ProtectMe source code -- http://maxence-dev.blogspot.com/
*Copyright (C) 2008  Maxence Ardouin maxthebest.dev@gmail.com
*
*This program is free software: you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation, either version 3 of the License, or
*(at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <pspkernel.h>
#include <pspctrl.h>
#include <pspdisplay.h>
#include <stdio.h>
#include <stdlib.h> 
#include <ctype.h>
#include <pspdebug.h> 
#include <time.h>
#include <string.h>
#include <pspmoduleinfo.h>
#include <pspaudiolib.h>
#include <pspaudio.h>
#include <math.h>
#include <limits.h>
#include <pspreg.h>

#define Wait Pause
#define printf   pspDebugScreenPrintf
#define wait Pause
#define Version "VF0.92"

PSP_MODULE_INFO("protect-me VF0.92", 0x800, 1, 1);

void Pause();
int Aff();
void menu();
int check();
int NO_ENTRY = 0;

const float PI = 3.1415926535897932f;
const int sampleRate = 44100;
float frequency = 440.0f;
float timer = 0;
int function = 0;
int z = 1;

typedef struct {
        short l, r;
} sample_t;

float currentFunction(const float timer) {
        double x;
	float t = modf(timer / (2 * PI), &x);
	        if (t < 0.5f) {
	                return -0.2f;
	        } 
			else {
	                return 0.2f;
	        }
}

void audioCallback(void* buf, unsigned int length, void *userdata) {
        const float sampleLength = 1.0f / sampleRate;
	const float scaleFactor = SHRT_MAX - 1.0f;
        static float freq0 = 440.0f;
       	sample_t* ubuf = (sample_t*) buf;
	int i;
	
	if (frequency != freq0) {
	        timer *= (freq0 / frequency);
	}
	for (i = 0; i < length; i++) {
	        short s = (short) (scaleFactor * currentFunction(2.0f * PI * frequency * timer));
		ubuf[i].l = s;
		ubuf[i].r = s;
		timer += sampleLength;
	}
	if (timer * frequency > 1.0f) {
	        double d;
		timer = modf(timer * frequency, &d) / frequency;
	}
	freq0 = frequency;
}


void controlFrequency(void) {
if(z==1)
{
frequency = 400.0f;
z = 0;
}
if(z==0)
{
frequency = 500.0f;
z = 1;
}
//sceKernelDelayThread(100*1000*2);
}

void Aff_Interface()
{
pspDebugScreenSetTextColor(0x77777777);
pspDebugScreenSetXY(0,0);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetXY(0,1);
printf("--                                                                --");
pspDebugScreenSetTextColor(0xffffffff);
pspDebugScreenSetXY(18,1);
printf("MaxTheBest's Protect-Me %s",Version);//68
pspDebugScreenSetTextColor(0x77777777);
pspDebugScreenSetXY(0,2);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetTextColor(0x00FF0000);
pspDebugScreenSetXY(0,3);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetXY(0,6);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetTextColor(0x77777777);
pspDebugScreenSetXY(0,28);
printf("--------------------------------------------------------------------");//68
pspDebugScreenSetXY(0,32);
printf("--------------------------------------------------------------------");//68//Last one ^^
}

void Display(char message[67],int t9)
{
    pspDebugScreenSetTextColor(0x00FF0000);
    pspDebugScreenSetXY(0,5);
	printf("%s",message);
	Wait(t9*1000);
	pspDebugScreenSetXY(0,5);
	printf("                                                                    ");
	pspDebugScreenSetXY(0,6);
    printf("--------------------------------------------------------------------");//68
}


int main(int argc, char **argv)
{
time_t heure;
SceCtrlData pad;
time(&heure);
FILE*historic = NULL;
historic = fopen("ms0:/PSP/SYSTEM/hist.txt", "a");
fprintf(historic,"PSP powered on %s",ctime(&heure));
char caractere = 'p';
char jour[10];
char moi[10];
char day[10];
char date[10];
char year[10];
FILE *temp = NULL;
temp = fopen("ms0:/TEMP.PM", "r");
if(temp!=NULL)
{
fscanf(temp,"%s %s  %s %s %s",jour,moi,day,date,year);
pspDebugScreenInit();
printf("PSP's Access was denied on:\nDay: %s %s %s %s\nHour: %s\n\nPress start to enter password",jour,day,moi,year,date);
while(1)
{
sceCtrlPeekBufferPositive(&pad, 1);
if(pad.Buttons & PSP_CTRL_START)
{
break;
}
}
}
fclose(temp);
FILE* save = NULL;
save = fopen("ms0:/PSP/SYSTEM/iso.m33", "r");
scanf("%c",&caractere);
   char word[8];
   word[0]='a';
   word[1]='a';
   word[2]='a';
   word[3]='a';
   word[4]='a';
   word[5]='a';
   word[6]='a';
   word[7]='a';
   word[8]='\0';
   char word2[8];
   word2[0]='a';
   word2[1]='a';
   word2[2]='a';
   word2[3]='a';
   word2[4]='a';
   word2[5]='a';
   word2[6]='a';
   word2[7]='a';
   word2[8]='\0';
      if(opendir("ms0:/PSP/SYSTEM")!=NULL)
	  {
	  if(save!=NULL)
	  {
	  pspDebugScreenInit();
   pspDebugScreenSetBackColor(0x00000000);
   pspDebugScreenSetTextColor(0xffffffff);
   Aff_Interface();
    pspDebugScreenSetBackColor(0x00000000);
    pspDebugScreenSetTextColor(0x77777777);
    pspDebugScreenSetXY(0,29);
    printf("Press Cross to validate letter\nStart go to XMB\nR to go right or L to go left");
         pspDebugScreenSetTextColor(0xffffffff);
		 Aff(0,0,0,word,word2);
         Pause(5000);
         menu();
      sceKernelDelayThread(1000);
	  fclose(historic);
	  }
	  
	  else
  {
  fprintf(historic,"No password installed, logged in");
  fclose(historic);
  }
  }
  else
  {
  fprintf(historic,"PSP/SYSTEM/ does not exist, logged in.\n");
  fclose(historic);
  }
   
   return 0;
}

int Aff(int select,int sel,int save,char word[8],char word2[8])
{
   int breake = 0;
   char passe[8];
   char letters[36];
   letters[0]='a';
   letters[1]='b';
   letters[2]='c';
   letters[3]='d';
   letters[4]='e';
   letters[5]='f';
   letters[6]='g';
   letters[7]='h';
   letters[8]='i';
   letters[9]='j';
   letters[10]='k';
   letters[11]='l';
   letters[12]='m';
   letters[13]='n';
   letters[14]='o';
   letters[15]='p';
   letters[16]='q';
   letters[17]='r';
   letters[18]='s';
   letters[19]='t';
   letters[20]='u';
   letters[21]='v';
   letters[22]='w';
   letters[23]='x';
   letters[24]='y';
   letters[25]='z';
   letters[26]='0';
   letters[27]='1';
   letters[28]='2';
   letters[29]='3';
   letters[30]='4';
   letters[31]='5';
   letters[32]='6';
   letters[33]='7';
   letters[34]='8';
   letters[35]='9';
   letters[36]='\0';
   int y = 10;
   int i = 0;
   pspDebugScreenSetTextColor(0xffffffff);
   while(i<=9)
   {
   pspDebugScreenSetXY(y,12);
   printf("%c",letters[i]);
   i++;
   y = y + 2;
   }
   y = 10;
   while(i<=19)
   {
   pspDebugScreenSetXY(y,14);
   printf("%c",letters[i]);
   i++;
   y = y + 2;
   }
   y = 10;
   while(i<=25)
   {
   pspDebugScreenSetXY(y,16);
   printf("%c",letters[i]);
   i++;
   y = y + 2;
   }
   y = 10;
   while(i<=35)
   {
   pspDebugScreenSetXY(y,18);
   printf("%c",letters[i]);
   i++;
   y = y + 2;
   }
   pspDebugScreenSetXY(0,13);
   printf("                                     ");
   pspDebugScreenSetXY(0,15);
   printf("                                     ");
   pspDebugScreenSetXY(0,17);
   printf("                                     ");
   pspDebugScreenSetXY(0,19);
   printf("                                     ");
   
   pspDebugScreenSetTextColor(0x00FF0000);
   switch (select)
   {
	case 0:
		pspDebugScreenSetXY(10,12);
		printf("a");
		break;
	case 1:
		pspDebugScreenSetXY(12,12);
		printf("b");
		break;
	case 2:
		pspDebugScreenSetXY(14,12);
		printf("c");
		break;
	case 3:
		pspDebugScreenSetXY(16,12);
		printf("d");
		break;
	case 4:
		pspDebugScreenSetXY(18,12);
		printf("e");
		break;
	case 5:
		pspDebugScreenSetXY(20,12);
		printf("f");
		break;
	case 6:
		pspDebugScreenSetXY(22,12);
		printf("g");
		break;
	case 7:
		pspDebugScreenSetXY(24,12);
		printf("h");
		break;
	case 8:
		pspDebugScreenSetXY(26,12);
		printf("i");
		break;
	case 9:
		pspDebugScreenSetXY(28,12);
		printf("j");
		break;
	case 10:
		pspDebugScreenSetXY(10,14);
		printf("k");
		break;
	case 11:
		pspDebugScreenSetXY(12,14);
		printf("l");
		break;
	case 12:
		pspDebugScreenSetXY(14,14);
		printf("m");
		break;
	case 13:
		pspDebugScreenSetXY(16,14);
		printf("n");
		break;
	case 14:
		pspDebugScreenSetXY(18,14);
		printf("o");
		break;
	case 15:
		pspDebugScreenSetXY(20,14);
		printf("p");
		break;
	case 16:
		pspDebugScreenSetXY(22,14);
		printf("q");
		break;
	case 17:
		pspDebugScreenSetXY(24,14);
		printf("r");
		break;
	case 18:
		pspDebugScreenSetXY(26,14);
		printf("s");
		break;
	case 19:
		pspDebugScreenSetXY(28,14);
		printf("t");
		break;
	case 20:
		pspDebugScreenSetXY(10,16);
		printf("u");
		break;
	case 21:
		pspDebugScreenSetXY(12,16);
		printf("v");
		break;
	case 22:
		pspDebugScreenSetXY(14,16);
		printf("w");
		break;
	case 23:
		pspDebugScreenSetXY(16,16);
		printf("x");
		break;
	case 24:
		pspDebugScreenSetXY(18,16);
		printf("y");
		break;
	case 25:
		pspDebugScreenSetXY(20,16);
		printf("z");
		break;
	case 26:
		pspDebugScreenSetXY(10,18);
		printf("0");
		break;
	case 27:
		pspDebugScreenSetXY(12,18);
		printf("1");
		break;
	case 28:
		pspDebugScreenSetXY(14,18);
		printf("2");
		break;
	case 29:
		pspDebugScreenSetXY(16,18);
		printf("3");
		break;
	case 30:
		pspDebugScreenSetXY(18,18);
		printf("4");
		break;
	case 31:
		pspDebugScreenSetXY(20,18);
		printf("5");
		break;
	case 32:
		pspDebugScreenSetXY(22,18);
		printf("6");
		break;
	case 33:
		pspDebugScreenSetXY(24,18);
		printf("7");
		break;
	case 34:
		pspDebugScreenSetXY(26,18);
		printf("8");
		break;
	case 35:
		pspDebugScreenSetXY(28,18);
		printf("9");
		break;
   }
   pspDebugScreenSetTextColor(0xffffffff);
   
   if(save==65)//activer la  lettre selectionn�e
   {
   word[sel]=letters[select];
   }
   
   if(save==89)//pour verifier le mdp...
   {
   word2[0] = word[0];
   word2[1] = word[1];
   word2[2] = word[2];
   word2[3] = word[3];
   word2[4] = word[4];
   word2[5] = word[5];
   word2[6] = word[6];
   word2[7] = word[7];
   word2[8]='\0';
   FILE* savefile = NULL;
   savefile = fopen("ms0:/PSP/SYSTEM/iso.m33", "r");
   breake = check(0,0,savefile,word,breake);
   }
   
   
   word2[0] = word[0];
   word2[1] = word[1];
   word2[2] = word[2];
   word2[3] = word[3];
   word2[4] = word[4];
   word2[5] = word[5];
   word2[6] = word[6];
   word2[7] = word[7];
   word2[8]='\0';
   //pspDebugScreenSetXY(10,10);
   //printf("word = [%s] word2 = [%s]",word,word2);
   pspDebugScreenSetTextColor(0x00FF0000);
   if(sel==0)
   {
   sprintf(passe,"%c*******",word[0]);
   }
   if(sel==1)
   {
   sprintf(passe,"*%c******",word[1]);
   }
   if(sel==2)
   {
   sprintf(passe,"**%c*****",word[2]);
   }
   if(sel==3)
   {
   sprintf(passe,"***%c****",word[3]);
   }
   if(sel==4)
   {
   sprintf(passe,"****%c***",word[4]);
   }
   if(sel==5)
   {
   sprintf(passe,"*****%c**",word[5]);
   }
   if(sel==6)
   {
   sprintf(passe,"******%c*",word[6]);
   }
   if(sel==7)
   {
   sprintf(passe,"*******%c",word[7]);
   }
   passe[8] = '\0';
   pspDebugScreenSetXY(0,4);
   printf("password: %s",passe);
   if(breake==12)
   {
   return 1;
   }
   else
   {
   return 0;
   }
}


void menu()
{
   int quit=0;
   int select = 0;
   int sel = 0;
   int save=0;
   char word[8];
   word[0]='a';
   word[1]='a';
   word[2]='a';
   word[3]='a';
   word[4]='a';
   word[5]='a';
   word[6]='a';
   word[7]='a';
   word[8]='\0';
   char rword[8];
   rword[0]='a';
   rword[1]='a';
   rword[2]='a';
   rword[3]='a';
   rword[4]='a';
   rword[5]='a';
   rword[6]='a';
   rword[7]='a';
   rword[8]='\0';
   u32 buttonsold = 0;
   word[0] = rword[0];
   word[1] = rword[1];
   word[2] = rword[2];
   word[3] = rword[3];
   word[4] = rword[4];
   word[5] = rword[5];
   word[6] = rword[6];
   word[7] = rword[7];
   word[8]='\0';
   Aff(select,sel,save,word,rword);
   while(quit == 0)
   {
      SceCtrlData pad;
      sceCtrlPeekBufferPositive(&pad, 1);
	  save = 0;
	  //quit = Aff(select,sel,save,word,rword);
	  if (quit == 1)
	  {
	  break;
	  }
	  //rword = Aff(select,sel,save,word);
	  //word = rword;
	  //sprintf(word,"%s",rword);
	  if (pad.Buttons != buttonsold) 
	  {
	  if(pad.Buttons & PSP_CTRL_LEFT)
	  {
	  select = select-1;
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  
	  if(pad.Buttons & PSP_CTRL_RIGHT)
	  {
	  select = select+1;
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_UP)
	  {
	  //MODIFIED
	  if(select>=10 && select<=25)
	  {
	  select = select-10;
	  }
	  else if(select>=26 && select<31)
	  {
	  select = select - 6;
	  }
	  else if(select>=31)
	  {
	  select = 25;
	  }
	  //END
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_DOWN)
	  {
	  //MODIFIED!!!
	  if(select>=0 && select<=15)
	  {
	  select = select + 10;
	  }
	  else if(select>=16 && select<=19)
	  {
	  select = 25;
	  }
	  else if(select>=20 && select<=25)
	  {
	  select = select + 6;
	  }
	  else if(select>=25)
	  {
	  select = 35;
	  }
	  //End 
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_LTRIGGER)
	  {
	  sel = sel-1;
	  if (sel<0)
	  {
	  sel=7;
	  }
	  if (sel>7)
	  {
	  sel=0;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_RTRIGGER)
	  {
	  sel = sel+1;
	  if (sel<0)
	  {
	  sel=7;
	  }
	  if (sel>7)
	  {
	  sel=0;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_CROSS)
	  {
	  quit = Aff(select,sel,65,word,rword);
	  word[0] = rword[0];
      word[1] = rword[1];
      word[2] = rword[2];
      word[3] = rword[3];
      word[4] = rword[4];
      word[5] = rword[5];
      word[6] = rword[6];
      word[7] = rword[7];
      word[8]='\0';
	  sel = sel+1;
	  if (sel<0)
	  {
	  sel=7;
	  }
	  if (sel>7)
	  {
	  sel=0;
	  }
	  quit = Aff(select,sel,save,word,rword);
	  }
	  if(pad.Buttons & PSP_CTRL_START)
	  {
	  FILE* savefile = NULL;
   savefile = fopen("ms0:/PSP/SYSTEM/iso.m33", "r");
   quit = check(0,0,savefile,word,quit);
   if(quit == 12)
   {
   break;
   }
	  /*Aff(select,sel,89,word,rword);
	  word[0] = rword[0];
      word[1] = rword[1];
      word[2] = rword[2];
      word[3] = rword[3];
      word[4] = rword[4];
      word[5] = rword[5];
      word[6] = rword[6];
      word[7] = rword[7];
      word[8]='\0';*/
	  
	  if (quit==1)
	  {
	  break;
	  }
	  }
	  
	  buttonsold = pad.Buttons;
	  }
	  if (select<=0)
	  {
	  select=0;
	  }
	  if (select>=35)
	  {
	  select=35;
	  }
	  if (sel<0)
	  {
	  sel=7;
	  }
	  if (sel>7)
	  {
	  sel=0;
	  }
	  //quit = Aff(select,sel,save,word,rword);
	  if (quit == 1)
	  {
	  break;
	  }
	  //rword = Aff(select,sel,save,word);
	  //word = rword;
	 // sprintf(word,"%s",rword);
      /*if(pad.Buttons & PSP_CTRL_SELECT)
      {
         quit = 1;
      }*/
   }
}


/*Centrer le texte*/
int centert(char *chaine){
int x1 = -1;
int length = 0;
length = strlen(chaine);
 x1 = 34-(length/2);
return x1;
}

void set_registry_value(const char *dir, const char *name, unsigned int val)
{
	struct RegParam reg;
	REGHANDLE h;

	memset(&reg, 0, sizeof(reg));
	reg.regtype = 1;
	reg.namelen = strlen("/system");
	reg.unk2 = 1;
	reg.unk3 = 1;
	strcpy(reg.name, "/system");
	if(sceRegOpenRegistry(&reg, 2, &h) == 0)
	{
		REGHANDLE hd;
		if(!sceRegOpenDir(h, dir, 2, &hd))
		{
			if(!sceRegSetKeyValue(hd, name, &val, 4))
			{
				sceRegFlushDir(hd);
			}
			sceRegCloseDir(hd);
		}
		sceRegFlushRegistry(h);
		sceRegCloseRegistry(h);
	}
}


int check(int yes,int cara,FILE*save,char password[8], int breake)
{
int alarm = -1;
FILE* fd = NULL;
fd = fopen("config.mtb","rb");
if(fd!=NULL)
{
fscanf(fd,"%i",&alarm);
}
fclose(fd);
time_t heure;
time(&heure);
FILE*historic1 = NULL;
historic1 = fopen("ms0:/PSP/SYSTEM/hist.txt", "a");
cara=0;
int i = 0;
yes=0;
int caractereActuel = 0;
   do
   {
   caractereActuel = fgetc(save);
	if(caractereActuel==password[cara]+cara+1)
	{
	yes++;
	}
	cara++;
    } while (cara != 8);
	if(yes==8)
	{
	FILE* suck = NULL;
	suck = fopen("ms0:/TEMP.PM", "r");
	if(suck!=NULL)
	{
	fclose(suck);
	sceIoRemove("ms0:/TEMP.PM");
	}
	time(&heure);
	Display("Password accepted.        Welcome!!!",10);
	fprintf(historic1,"Password accepted on %s",ctime(&heure));
	fclose(save);
	fclose(historic1);
	breake = 12;
	}
	else
	{
	time(&heure);
	char wrongpass[20];
	wrongpass[0] = 'E';
	wrongpass[1] = 'R';
	wrongpass[2] = 'R';
	wrongpass[3] = 'O';
	wrongpass[4] = 'R';
	wrongpass[5] = ' ';
	wrongpass[6] = 'W';
	wrongpass[7] = 'R';
	wrongpass[8] = 'O';
	wrongpass[9] = 'N';
	wrongpass[10] = 'G';
	wrongpass[11] = ' ';
	wrongpass[12] = 'P';
	wrongpass[13] = 'A';
	wrongpass[14] = 'S';
	wrongpass[15] = 'S';
	wrongpass[16] = 'W';
	wrongpass[17] = 'O';
	wrongpass[18] = 'R';
	wrongpass[19] = 'D';
	wrongpass[20] = '\0';
	Display(wrongpass,10);
	fprintf(historic1,"This password: \"%c%c%c%c%c%c%c%c\" was refused on %s",password[0],password[1],password[2],password[3],password[4],password[5],password[6],password[7],ctime(&heure));
	fclose(historic1);
	NO_ENTRY++;
	if(NO_ENTRY>=3)
	{
	if(alarm==1)
	{
	set_registry_value("/CONFIG/SYSTEM/SOUND", "main_volume", 30);
	}
	FILE* suck = NULL;
    suck = fopen("ms0:/TEMP.PM", "w+");
	fprintf(suck,"%s",ctime(&heure));
	fclose(suck);
	sceKernelDelayThread(100*1000*2);
	pspDebugScreenInit();
	pspDebugScreenClear();
	pspDebugScreenSetBackColor(0x00000000);
	pspDebugScreenSetTextColor(0x000A0AEE);
	time(&heure);
	pspDebugScreenSetTextColor(0x000A0AEE);
	printf("TIME OF INTRUSION: %s",ctime(&heure));
	if(alarm==1)
	{
	pspAudioInit();
	pspAudioSetChannelCallback(0, audioCallback, NULL);
	}
while(1)
{
 i++;
 if(i<=4000)
 {
 pspDebugScreenSetTextColor(0x000A0AEE);
 pspDebugScreenSetXY(centert("ALERT ACCESS DENIED, UNAUTHORIZED INTRUSION!"),15);
 printf("ALERT ACCESS DENIED, UNAUTHORIZED INTRUSION!");
   pspDebugScreenSetTextColor(0xffffffff);
 pspDebugScreenSetXY(centert("ALERT ACCESS DENIED, UNAUTHORIZED INTRUSION!"),25);
 printf("ALERT ACCESS DENIED, UNAUTHORIZED INTRUSION!");
 }
 if(i>=4000)
 {
  pspDebugScreenSetTextColor(0xffffffff);
  pspDebugScreenSetXY(centert("ALERT ACCESS DENIED, UNAUTHORIZED INTRUSION!"),15);
  printf("ALERT ACCESS DENIED, UNAUTHORIZED INTRUSION!");
  pspDebugScreenSetTextColor(0x000A0AEE);
  pspDebugScreenSetXY(centert("ALERT ACCESS DENIED, UNAUTHORIZED INTRUSION!"),25);
  printf("ALERT ACCESS DENIED, UNAUTHORIZED INTRUSION!");
  }
  if(i>=8000)
  {
  i = 0;
 }
}
}
}
return breake;
}

void Pause(int atemp)
{
      int atempo;
      int atempo2;
      atempo = 0;
      
   while (atempo < atemp)
   {
      atempo++;
      atempo2 = 0;
      while (atempo2 < atemp) {atempo2++;}
   }
}

void* getModuleInfo(void)
{
   return (void *) &module_info;
}
